diff -u -r postgresql-7.0.2/src/Makefile.global.in postgresql-7.0.2.new/src/Makefile.global.in
--- postgresql-7.0.2/src/Makefile.global.in	Tue May 23 03:12:46 2000
+++ postgresql-7.0.2.new/src/Makefile.global.in	Mon Jun 12 13:00:13 2000
@@ -161,6 +161,8 @@
 #
 # enable native odbc driver support
 USE_ODBC= @USE_ODBC@
+SHLIB_ODBC =@SHLIB_ODBC@
+
 
 X_CFLAGS= @X_CFLAGS@
 X_LIBS= @X_LIBS@
diff -u -r postgresql-7.0.2/src/configure.in postgresql-7.0.2.new/src/configure.in
--- postgresql-7.0.2/src/configure.in	Wed May 24 23:43:59 2000
+++ postgresql-7.0.2.new/src/configure.in	Mon Jun 12 13:00:13 2000
@@ -368,6 +368,24 @@
 )
 export USE_ODBC
 
+dnl check if we want to use unixODBC to provide access to the odbc.ini
+dnl files
+
+use_unixODBC=no
+AC_MSG_CHECKING(setting USE_UNIXODBC)
+AC_ARG_WITH(
+    unixODBC,
+    [  --with-unixODBC[=DIR]   Use unixODBC located in DIR],
+    [
+        use_unixODBC=yes;
+        unixODBC="$withval";
+        USE_ODBC=true;
+        AC_MSG_RESULT(enabled);
+    ],
+    [ USE_ODBC=false; use_unixODBC=no; AC_MSG_RESULT(disabled) ]
+)
+export USE_ODBC
+
 AC_MSG_CHECKING(setproctitle)
 AC_ARG_WITH(
    setproctitle,
@@ -408,6 +426,41 @@
 fi
 AC_SUBST(ODBCINSTDIR)
 
+#check for unixODBC libs
+
+if test "x$use_unixODBC" = "xyes"
+then
+
+  # default to /usr/local if not specified
+  if test "x$unixODBC" = "x"
+  then
+      unixODBC="/usr/local";
+  fi
+  
+  unixODBC_libs="$unixODBC/lib"
+  unixODBC_includes="$unixODBC/include"
+
+  CPPFLAGS="$CPPFLAGS -I$unixODBC_includes"
+  AC_CHECK_HEADERS(sql.h sqlext.h odbcinst.h,
+          unixODBC_ok=yes;
+          odbc_headers="$odbc_headers $ac_hdr",
+          unixODBC_ok=no )
+  
+  if test "x$unixODBC_ok" != "xyes"
+  then
+      AC_MSG_ERROR([Unable to find the unixODBC headers in $1])
+  fi
+ 
+  save_LIBS="$LIBS"
+  LIBS="-L$unixODBC_libs $LIBS"
+  
+  AC_CHECK_LIB(odbcinst,SQLGetPrivateProfileString,
+    [AC_DEFINE(HAVE_SQLGETPRIVATEPROFILESTRING)
+    SHLIB_ODBC="$LDFLAGS_ODBC -L$unixODBC_libs -lodbcinst" ],
+    [LIBS="$save_LIBS"] )
+fi
+export SHLIB_ODBC
+
 dnl Unless we specify the command line options
 dnl	--enable cassert	to explicitly enable it
 dnl If you do not explicitly do it, it defaults to disabled
@@ -507,6 +560,7 @@
 AC_SUBST(WISH)
 AC_SUBST(USE_PERL)
 AC_SUBST(USE_ODBC)
+AC_SUBST(SHLIB_ODBC)
 AC_SUBST(MULTIBYTE)
 
 dnl Check for C++ support (allow override if needed)
diff -u -r postgresql-7.0.2/src/include/config.h.in postgresql-7.0.2.new/src/include/config.h.in
--- postgresql-7.0.2/src/include/config.h.in	Fri May 12 14:58:25 2000
+++ postgresql-7.0.2.new/src/include/config.h.in	Mon Jun 12 13:00:13 2000
@@ -315,6 +315,9 @@
  * Block of parameters for the ODBC code.
  */
 
+/* are we building against a libodbcinst */
+#undef HAVE_SQLGETPRIVATEPROFILESTRING
+
 /* Set to 1 if you have <pwd.h> */
 #undef HAVE_PWD_H
 
diff -u -r postgresql-7.0.2/src/interfaces/odbc/bind.c postgresql-7.0.2.new/src/interfaces/odbc/bind.c
--- postgresql-7.0.2/src/interfaces/odbc/bind.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/bind.c	Tue Jun 20 13:43:22 2000
@@ -36,7 +36,7 @@
 
 //      Bind parameters on a statement handle
 
-RETCODE SQL_API SQLBindParameter(
+RETCODE SQL_API PG__SQLBindParameter(
         HSTMT      hstmt,
         UWORD      ipar,
         SWORD      fParamType,
@@ -140,10 +140,34 @@
 	return SQL_SUCCESS;
 }
 
+RETCODE SQL_API SQLBindParameter(
+        HSTMT      hstmt,
+        UWORD      ipar,
+        SWORD      fParamType,
+        SWORD      fCType,
+        SWORD      fSqlType,
+        UDWORD     cbColDef,
+        SWORD      ibScale,
+        PTR        rgbValue,
+        SDWORD     cbValueMax,
+        SDWORD FAR *pcbValue)
+{
+    return PG__SQLBindParameter( hstmt,
+            ipar,
+            fParamType,
+            fCType,
+            fSqlType,
+            cbColDef,
+            ibScale,
+            rgbValue,
+            cbValueMax,
+            pcbValue );
+}
+
 //      -       -       -       -       -       -       -       -       -
 
 //      Associate a user-supplied buffer with a database column.
-RETCODE SQL_API SQLBindCol(
+RETCODE SQL_API PG__SQLBindCol(
         HSTMT      hstmt,
         UWORD      icol,
         SWORD      fCType,
@@ -428,4 +452,20 @@
 	//	SQLExecDirect(...)	# returns 10 cols  (now OK)
 
 	mylog("exit extend_bindings\n");
+}
+
+RETCODE SQL_API SQLBindCol(
+        HSTMT      hstmt,
+        UWORD      icol,
+        SWORD      fCType,
+        PTR        rgbValue,
+        SDWORD     cbValueMax,
+        SDWORD FAR *pcbValue)
+{
+    return PG__BindCol( hstmt,
+            icol,
+            fCType,
+            rgbValue,
+            cbValueMax,
+            pcbValue );
 }
diff -u -r postgresql-7.0.2/src/interfaces/odbc/connection.c postgresql-7.0.2.new/src/interfaces/odbc/connection.c
--- postgresql-7.0.2/src/interfaces/odbc/connection.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/connection.c	Tue Jun 20 13:43:22 2000
@@ -1223,7 +1223,7 @@
 	has not transitioned to "connected" yet.
 */
 
-	result = SQLAllocStmt( self, &hstmt);
+	result = PG__SQLAllocStmt( self, &hstmt);
 	if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO)) {
 		return FALSE;
 	}
@@ -1232,7 +1232,7 @@
 	stmt->internal = TRUE;	/* ensure no BEGIN/COMMIT/ABORT stuff */
 
 	/*	Set the Datestyle to the format the driver expects it to be in */
-	result = SQLExecDirect(hstmt, "set DateStyle to 'ISO'", SQL_NTS);
+	result = PG__SQLExecDirect(hstmt, "set DateStyle to 'ISO'", SQL_NTS);
 	if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO))
 		status = FALSE;
 
@@ -1240,7 +1240,7 @@
 
 	/*	Disable genetic optimizer based on global flag */
 	if (globals.disable_optimizer) {
-		result = SQLExecDirect(hstmt, "set geqo to 'OFF'", SQL_NTS);
+		result = PG__SQLExecDirect(hstmt, "set geqo to 'OFF'", SQL_NTS);
 		if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO))
 			status = FALSE;
 
@@ -1250,7 +1250,7 @@
 
 	/*	KSQO */
 	if (globals.ksqo) {
-		result = SQLExecDirect(hstmt, "set ksqo to 'ON'", SQL_NTS);
+		result = PG__SQLExecDirect(hstmt, "set ksqo to 'ON'", SQL_NTS);
 		if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO))
 			status = FALSE;
 
@@ -1263,7 +1263,7 @@
 		cs = strdup(globals.conn_settings);
 		ptr = strtok(cs, ";");
 		while (ptr) {
-			result = SQLExecDirect(hstmt, ptr, SQL_NTS);
+			result = PG__SQLExecDirect(hstmt, ptr, SQL_NTS);
 			if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO))
 				status = FALSE;
 
@@ -1280,7 +1280,7 @@
 		cs = strdup(ci->conn_settings);
 		ptr = strtok(cs, ";");
 		while (ptr) {
-			result = SQLExecDirect(hstmt, ptr, SQL_NTS);
+			result = PG__SQLExecDirect(hstmt, ptr, SQL_NTS);
 			if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO))
 				status = FALSE;
 
@@ -1293,7 +1293,7 @@
 	}
 
 
-	SQLFreeStmt(hstmt, SQL_DROP);
+	PG__SQLFreeStmt(hstmt, SQL_DROP);
 
 	return status;
 }
@@ -1315,34 +1315,34 @@
 /*	This function must use the local odbc API functions since the odbc state 
 	has not transitioned to "connected" yet.
 */
-	result = SQLAllocStmt( self, &hstmt);
+	result = PG__SQLAllocStmt( self, &hstmt);
 	if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO)) {
 		return;
 	}
 	stmt = (StatementClass *) hstmt;
 
-	result = SQLExecDirect(hstmt, "select oid from pg_type where typname='" PG_TYPE_LO_NAME "'", SQL_NTS);
+	result = PG__SQLExecDirect(hstmt, "select oid from pg_type where typname='" PG_TYPE_LO_NAME "'", SQL_NTS);
 	if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO)) {
-		SQLFreeStmt(hstmt, SQL_DROP);
+		PG__SQLFreeStmt(hstmt, SQL_DROP);
 		return;
 	}
 
-	result = SQLFetch(hstmt);
+	result = PG__SQLFetch(hstmt);
 	if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO)) {
-		SQLFreeStmt(hstmt, SQL_DROP);
+		PG__SQLFreeStmt(hstmt, SQL_DROP);
 		return;
 	}
 
-	result = SQLGetData(hstmt, 1, SQL_C_SLONG, &self->lobj_type, sizeof(self->lobj_type), NULL);
+	result = PG__SQLGetData(hstmt, 1, SQL_C_SLONG, &self->lobj_type, sizeof(self->lobj_type), NULL);
 	if((result != SQL_SUCCESS) && (result != SQL_SUCCESS_WITH_INFO)) {
-		SQLFreeStmt(hstmt, SQL_DROP);
+		PG__SQLFreeStmt(hstmt, SQL_DROP);
 		return;
 	}
 
 	mylog("Got the large object oid: %d\n", self->lobj_type);
 	qlog("    [ Large Object oid = %d ]\n", self->lobj_type);
 
-	result = SQLFreeStmt(hstmt, SQL_DROP);
+	result = PG__SQLFreeStmt(hstmt, SQL_DROP);
 }
 
 void
diff -u -r postgresql-7.0.2/src/interfaces/odbc/dlg_specific.c postgresql-7.0.2.new/src/interfaces/odbc/dlg_specific.c
--- postgresql-7.0.2/src/interfaces/odbc/dlg_specific.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/dlg_specific.c	Tue Jun 20 13:44:45 2000
@@ -23,8 +23,10 @@
 #ifndef WIN32
 #include <string.h>
 #include "gpps.h"
+#ifndef HAVE_SQLGETPRIVATEPROFILESTRING
 #define SQLGetPrivateProfileString(a,b,c,d,e,f) GetPrivateProfileString(a,b,c,d,e,f)
 #define SQLWritePrivateProfileString(a,b,c,d) WritePrivateProfileString(a,b,c,d)
+#endif
 #ifndef HAVE_STRICMP
 #define stricmp(s1,s2)	strcasecmp(s1,s2)
 #define strnicmp(s1,s2,n)	strncasecmp(s1,s2,n)
diff -u -r postgresql-7.0.2/src/interfaces/odbc/execute.c postgresql-7.0.2.new/src/interfaces/odbc/execute.c
--- postgresql-7.0.2/src/interfaces/odbc/execute.c	Wed May 17 16:36:37 2000
+++ postgresql-7.0.2.new/src/interfaces/odbc/execute.c	Tue Jun 20 13:43:22 2000
@@ -125,7 +125,7 @@
 
 //      Performs the equivalent of SQLPrepare, followed by SQLExecute.
 
-RETCODE SQL_API SQLExecDirect(
+RETCODE SQL_API PG__SQLExecDirect(
         HSTMT     hstmt,
         UCHAR FAR *szSqlStr,
         SDWORD    cbSqlStr)
@@ -176,14 +176,22 @@
 	
 	mylog("%s: calling SQLExecute...\n", func);
 
-	result = SQLExecute(hstmt);
+	result = PG__SQLExecute(hstmt);
 
 	mylog("%s: returned %hd from SQLExecute\n", func, result);
 	return result;
 }
 
+RETCODE SQL_API SQLExecDirect(
+        HSTMT     hstmt,
+        UCHAR FAR *szSqlStr,
+        SDWORD    cbSqlStr )
+{
+	return PG__SQLExecDirect( hstmt, szSqlStr, cbSqlStr );
+}
+
 //      Execute a prepared SQL statement
-RETCODE SQL_API SQLExecute(
+RETCODE SQL_API PG__SQLExecute(
         HSTMT   hstmt)
 {
 static char *func="SQLExecute";
@@ -293,11 +301,15 @@
 
 }
 
-
+RETCODE SQL_API SQLExecute(
+        HSTMT   hstmt)
+{
+    return PG__SQLExecute( hstmt );
+}
 
 
 //      -       -       -       -       -       -       -       -       -
-RETCODE SQL_API SQLTransact(
+RETCODE SQL_API PG__SQLTransact(
         HENV    henv,
         HDBC    hdbc,
         UWORD   fType)
@@ -324,7 +336,7 @@
 			conn = conns[lf];
 
 			if (conn && conn->henv == henv)
-				if ( SQLTransact(henv, (HDBC) conn, fType) != SQL_SUCCESS)
+				if ( PG__SQLTransact(henv, (HDBC) conn, fType) != SQL_SUCCESS)
 					return SQL_ERROR;
 
 		}
@@ -371,6 +383,14 @@
 	return SQL_SUCCESS;
 }
 
+RETCODE SQL_API SQLTransact(
+        HENV    henv,
+        HDBC    hdbc,
+        UWORD   fType)
+{
+    return PG__SQLTransact( henv, hdbc, fType );
+}
+
 //      -       -       -       -       -       -       -       -       -
 
 RETCODE SQL_API SQLCancel(
@@ -411,10 +431,10 @@
 			result = addr( (char *) (stmt->phstmt) - 96, SQL_CLOSE);
 		}
 		else {
-			result = SQLFreeStmt( hstmt, SQL_CLOSE);
+			result = PG__SQLFreeStmt( hstmt, SQL_CLOSE);
 		}
 #else
-		result = SQLFreeStmt( hstmt, SQL_CLOSE);
+		result = PG__SQLFreeStmt( hstmt, SQL_CLOSE);
 #endif
 
 		mylog("SQLCancel:  SQLFreeStmt returned %d\n", result);
